# setQRG - settaggio della frequenza e switch degli integrati PLL MC145156 e MC145158

setQRG settaggio della frequenza di ricezione e trasmisione ed i pin SW1 e SW2 dell'ic PLL
(solo per MC145156).

setQRG lavora con i mini PC ODROID-C1 ed ORANGE PI ZERO. Il programma usa i pin GPIO per
settare i due PLL per RX e TX inviando una stringa di bit come previsto dai datasheet.

Supporta integrati PLL MC145156 e MC145158

Il programma memorizza gli ultimi valori inseriti codificati JSON in un file di testo.
Quindi, solo i valori da modificare devono essere specificati quando viene chiamato un 
comando, il resto viene automaticamente letto dai dati memorizzati.

Se il programma viene richiamato senza parametri, vengono trasmessi nuovamente gli ultimi
dati memorizzati.
**In questo modo il programma può essere eseguito all'avvio del sistema**


# Parametri selezionabili

Il programma è attualmente progettato per settare 2 circuiti integrati PLL (Rx e Tx). 
Pertanto è possibile specificare un totale di 6 valori:

**--rx** : frequenza di ricezione
**--tx** : frequenza di trasmissione
**--sw1_rx** : SW1 di RX-IC
**--sw2_rx** : SW2 di RX-IC
**--sw1_tx** : SW1 di TX-IC
**--sw2_tx** : SW2 di TX-IC

I pin utilizzati per controllare i PLL-IC Rx e Tx sono configurati nei rispettivi modulo
driver, è possibile scegliere tra **qrg_odroid_gpio.py** e **qrg_orange_gpio.py** (vedi
"impostazioni").


# Impostazioni

Copiare tutti i file decompressi dal programma setQRG nella cartella /opt ad es. con WinSCP
Passare nella cartella /opt: 

	cd /opt

Aprire il file **setQRG.py** con un editor di testo: 

	nano setQRG.py

Selezionare l'interfaccia: **qrg_odroid_gpio** o **qrg_orange_gpio
Selezionare il file dei parametri: **MB45_qrgparam** o **McC_qrgparam
Selezionare PLL Ic: **mc145156** o **mc145158**
Step QRG (kHz): 12.5
Frequenza di riferimento PLL (kHz): 12500 (MB45) o 14400 (McCompact VHF)
Valore parziale del prescaler: 64 (MB45) o 40 (McCompact VHF)
Media frequenza RX: 21400
Salvare il file con

	Cntl-x

Aprire il file **qrg_orange_gpio.py** o **qrg_odroid_gpio.py** con un editor di testo: 

	nano qrg_orange_gpio.py

Definire il numero di pin del ODROID C1 o dell'ORANGE PI ZERO per le linee dati del PLL
data, clock, enable RX ed enable TX.

Per l'ODROID devono essere indicati i numero di GPIO (vedi tabella inserita nel file) 
mentre per l'ORANGE PI devono essere indicati i numeri pin del connettore (vedi tabella
inserita nel file)!

Esempio (per ORANGE PI ZERO):
DATA_PIN = 12
CLK_PIN = 13
ENB_RX_PIN = 15
ENB_TX_PIN = 16

Salvare con 

	CNTL-X


#Installazione del programma **Python** ed compilazione del programma **setQRG**

	apt-get install python-pip	(installazione compiler)
	pip install Opi.GPIO		(installazione gpio handling per Orange Pi Zero) **O**
	pip install wiringpi2		(installazione gpio handling per Odroid C1)
	#!/bin/bash
	python /opt/setQRG.py $@	(compilazone del programma, verra creato il file 
								**qrg_orange_gpio.pyc** o **qrg_odroid_gpio.pyc**)
	cd ..						(cambiare nella cartella root)


#Comandi

usage: setQRG [-h] [--tx TX] [--rx RX] [--sw1_rx SW1_RX] [--sw2_rx SW2_RX]
              [--sw1_tx SW1_TX] [--sw2_tx SW2_TX] [--txpower TXPOWER]

setQRG - Frequency programming for Motorola MC145156
         PLL Frequency Synthesizer

Copyright (C) 2015, Simon Kofler, IN3FQQ
Licence: GPLv3

optional arguments:
  -h, --help         show this help message and exit
  --tx TX            TX Frequency in kHz
  --rx RX            RX Frequency in kHz
  --sw1_rx SW1_RX    SW1 flag for the RX PLL IC (MC145156 Pin 14)
  --sw2_rx SW2_RX    SW2 flag for the RX PLL IC (MC145156 Pin 15)
  --sw1_tx SW1_TX    SW1 flag for the TX PLL IC (MC145156 Pin 14)
				     RF OUTPUT POWER SETTING for ITALTEL MB-45 (1:high, 0:low)
  --sw2_tx SW2_TX    SW2 flag for the TX PLL IC (MC145156 Pin 15)
  --txpower TXPOWER  RF OUTPUT POWER for MC-Compact (MC145158) (1:high, 0:low)


#Esempio

	Descrizione			Comando
	
	setQRG stato: 		setQRG
	setQRG help:   		setQRG -h
	set QRG (kHz):	    setQRG --tx 431400.0 --rx 433025.0
	TX power low:  		setQRG --sw1_tx 0
	TX power high: 		setQRG --sw1_tx 1 

